SystemOrganization addCategory: #Proves!

Object subclass: #Pasta
	instanceVariableNames: 'moneda quantitat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proves'!

!Pasta class methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 9/14/2012 13:36'!
moneda: unaString quantitat: unNombre
	^ self new moneda: unaString; quantitat: unNombre! !

!Pasta methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 9/14/2012 13:37'!
+ unaPasta
	self moneda = unaPasta moneda
		ifTrue: [ ^Pasta moneda: self moneda quantitat: (self quantitat + unaPasta quantitat) ]
		ifFalse: [ self error: 'No es poden sumar monedes diferents' ].
		! !

!Pasta methodsFor: 'accessing' stamp: 'ChristianMartinBLas 9/14/2012 12:39'!
= unaPasta
	^ self moneda = unaPasta moneda and: [ self quantitat = unaPasta quantitat]! !

!Pasta methodsFor: 'accessing' stamp: 'ChristianMartinBLas 9/14/2012 12:32'!
moneda

	^ moneda! !

!Pasta methodsFor: 'accessing' stamp: 'ChristianMartinBLas 9/14/2012 12:32'!
moneda: anObject

	moneda := anObject! !

!Pasta methodsFor: 'accessing' stamp: 'ChristianMartinBLas 9/14/2012 12:32'!
quantitat

	^ quantitat! !

!Pasta methodsFor: 'accessing' stamp: 'ChristianMartinBLas 9/14/2012 12:32'!
quantitat: anObject

	quantitat := anObject! !

!Integer methodsFor: '*Proves' stamp: 'ChristianMartinBLas 9/14/2012 15:11'!
euro
	^ Pasta moneda: 'EUR' quantitat: self! !

TestCase subclass: #PastaTest
	instanceVariableNames: 'eur5 eur10 eur20'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proves'!

!PastaTest methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 9/14/2012 15:12'!
setUp
	eur5 := 5 euro.
	eur10 := 10 euro.
	eur20 := 20 euro.! !

!PastaTest methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 9/14/2012 12:36'!
testIguals
	self assert: eur5 = eur5.
	self assert: eur5 = (Pasta new moneda: 'EUR'; quantitat: 5). 
	self assert: eur5 ~= eur10.! !

!PastaTest methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 9/14/2012 12:42'!
testSuma
	self assert: eur5 + eur5 = eur10.
	self assert: eur10 + eur10 = eur20.
	self assert: eur20 = (eur5 + eur5 + eur5 + eur5).! !
